<template>
  <ob-form
    class="contract-service-form"
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!isDraft"
    data-qa="serviceForm"
    @submit="onSubmitHandler"
    :ok-text="isNew ? 'Добавить' : 'Сохранить'"
    cancel-text="Отменить"
  >
    <ObSelect
      ref="serviceSelect"
      v-if="isNew"
      v-model="formData.uuid"
      label="Услуга"
      placeholder="Выберите из списка"
      :display-func="(data) => `${data.title}. ${data.subtitle}`"
      :remote-opt="{
        method: api.contract.getServices,
        loadEvent: 'open',
        arguments: {
          caste: 'TRACKING',
          uuid: contract.uuid
        }
      }"
      property="uuid"
      class="mb20"
      data-qa="service"
      @selected="selectedService"
    />
    <ObInput
      v-else
      :value="dataSource.serviceTypeTitle"
      label="Услуга"
      :disabled="true"
    />
    <div class="row mb30">
      <div class="col-xs-6">
        <ObSelect
          v-if="isNew"
          v-model="formData.serviceUnitUuid"
          :items="formData.serviceUnits"
          :is-standart="false"
          label="Единица измерения услуги"
          placeholder="Сначала выберите услугу"
          data-qa="serviceUnit"
        />
        <ObInput
          v-else
          label="Единица измерения услуги"
          :readonly="true"
          :value="dataSource.serviceUnitTitle"
          icon="chevron-down"
          data-qa="serviceUnit"
        />
      </div>
    </div>
    <div class="sub-title">
      Описание
    </div>
    <p class="mb30">Расчет планового прибытия ТС на точки маршрута, уведомления об опозданиях и прогноз времени прибытия в конечные точки маршрута</p>
    <div class="sub-title">
      <span>Налог на добавленную стоимость (НДС)</span>
      <ObTooltip content="НДС">
        <i class="icon question" />
      </ObTooltip>
    </div>
    <ObRadio
      v-if="isNew"
      v-model="formData.isNds"
      label="Не облагается НДС"
      :valueInput="false"
      class="mb10"
      data-qa="isNotNds"
      :disabled="true"
      @change="clearNds"
    />
    <ObRadio
      v-model="formData.isNds"
      v-if="isNew"
      label="Облагается НДС"
      :valueInput="true"
      class="mb10"
      data-qa="isNds"
      @change="setDefaultNds"
    />
    <transition name="toggle-height">
      <div
        v-if="formData.isNds || !isNew"
        class="checkbox-input"
        :class="isNew && 'ml25'"
      >
        <ObInput
          v-model="formData.vatValue"
          label="Величина НДС"
          sub-title="%"
          placeholder="Укажите"
          class="input-nds"
          type="number:strict"
          :readonly="true"
          data-qa="vatValue"
        />
        <ObCheckbox
          v-model="formData.isVatInclude"
          label="Тарифы указываются с учётом НДС"
          data-qa="isVatInclude"
          :disabled="!isDraft"
        />
      </div>
    </transition>
    <div class="sub-title mt20">
      Тариф для GSM
    </div>
    <div class="description">
      За каждое ТС, при отправке по интеграции и e-mail
    </div>
    <ObInput
      v-model="formData.gsmTariff"
      label="Тариф"
      sub-title="₽"
      placeholder="Укажите"
      type="money:2"
      data-qa="gsmTariff"
      class="tariff-input"
      :readonly="!isDraft"
    />
    <div class="sub-title mt20">
      Тариф для бортового устройства
    </div>
    <div class="description">
      За каждое ТС, при отправке по интеграции и e-mail
    </div>
    <ObInput
      v-model="formData.onboardDeviceTariff"
      label="Тариф за каждое ТС"
      sub-title="₽"
      placeholder="Укажите"
      type="money:2"
      data-qa="onboardDeviceTariff"
      class="tariff-input"
      :readonly="!isDraft"
    />
    <div class="sub-title mt20">
      Тариф для мобильного приложения
    </div>
    <div class="description">
      За каждое ТС, при отправке по интеграции и e-mail
    </div>
    <ObInput
      v-model="formData.mobileAppTariff"
      label="Тариф"
      sub-title="₽"
      placeholder="Укажите"
      type="money:2"
      data-qa="mobileAppTariff"
      class="tariff-input"
      :readonly="!isDraft"
    />
  </ob-form>
</template>

<script>
  import { mapGetters } from 'vuex'
  import api from '@/api'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import models from '@/models'
  import cloneDeep from 'clone-deep'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObRadio from 'common-components/src/obComponents/obRadio'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObTooltip from 'common-components/src/obComponents/obTooltip'

  export default {
    name: 'ContractServiceTrackingForm',
    components: {
      ObSelect,
      ObInput,
      ObForm,
      ObCheckbox,
      ObRadio,
      ObTooltip
    },
    mixins: [
      FormValidationMixin
    ],
    data () {
      return {
        api,
        isNds: true
      }
    },
    computed: {
      ...mapGetters({
        contract: 'contract/contract',
        isDraft: 'contract/isDraft'
      }),
      disabledKeyWords () {
        return this.isNew ? false : !this.dataSource.is_active
      },
      isNew () {
        return !this.dataSource || !this.dataSource.uuid
      },
      formModel () {
        if (this.isNew) {
          return models.contract.serviceTracking
        } else {
          return models.contract.serviceTrackingEdit
        }

      },
    },
    watch: {
      dataSource () {
        // Ндс пока обязателен всегда
        // if(!this.isNew) {
        //   this.$nextTick(() => {
        //     this.isNds = this.dataSource.vatValue !== null
        //   })
        // }
      }
    },
    methods: {
      afterInitForm () {
        if (this.$refs.serviceSelect) {
          this.$refs.serviceSelect.firstLoad = true
        }
      },
      onSubmitHandler () {
        let data = cloneDeep(this.formData)
        delete data.serviceUnits

        this.$emit('submit', {formData: data, model: this.formModel})
      },
      clearNds () {
        this.formData.vatValue = null
        this.formData.isVatInclude = true
      },
      setDefaultNds () {
        this.formData.vatValue = 20
      },
      selectedService (item) {
        this.formData.contractUuid = this.$route.query.id
        this.formData.serviceDictUuid = item.uuid
        this.formData.serviceUnitUuid = item.serviceTypeUuid
        this.formData.serviceUnits = item.serviceUnits
        let data = item.serviceUnits
        data.map((i) => { i.label = i.title })
        this.serviceUnits = data
      }
    }
  }
</script>

<style lang='scss' scoped>
  @import '~common-components/src/static/css/mixins';

  .contract-service-form {
    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
      .icon {
        margin-left: 3px;
        font-size: 14px;
        font-weight: bold;
        color: $color-grey-span;
      }
    }

    .description {
      margin-bottom: 10px;
      @include font-mixin(12px, 12px, 400, $color-grey-label, 0.4px);
    }

    p {
      @include font-mixin(14px, 18px, 400, $color-grey-label, 0.2px);
    }

    .tariff-input {
      width: 240px;
    }
  }
</style>

<style lang="scss">
  .contract-service-form {
    .mt20 {
      margin-top: 20px!important;
    }

    .mb10 {
      margin-bottom: 10px;
    }

    .mb30 {
      margin-bottom: 30px!important;
    }

    .ml25 {
      margin-left: 25px;
    }

    .checkbox-input {
      display: flex;
      justify-content: flex-start;
      align-items: center;

      .ob-checkbox-container {
        flex-shrink: 0;
        margin-left: 20px;
      }
    }

    .input-nds {
      width: 145px;
    }
  }
</style>
